/************************************************************

		reports.h

   Constants, globals, and extern functions from reports.c

************************************************************/

#define XNUMBITS        4
#define YNUMBITS        4
#define ZNUMBITS        3
#define STDNUMBITS	11


/* modes of position reporting */

#define MOTOR		0
#define ENCODER		1
#define CUMULATIVE	2


/* codes for indexer status */

#define BAD_REPORT		0
#define READY			1
#define READY_ATTENTION		2
#define BUSY			3
#define BUSY_ATTENTION		4
#define SEQINPROG		5
#define SEQINPROG_ATTENTION	6



/* codes for pause status */

#define TRIGGER	 	0
#define HOLD	 	1
#define PAUSE	 	2
#define SHUTDOWN 	3
#define STOP	 	4

#define TRIGGER_BIT	0x01
#define HOLD_BIT	0x02
#define PAUSE_BIT	0x04
#define SHUTDOWN_BIT	0x08
#define STOP_BIT	0x10



/* codes for closed loop status */

#define STALL			0
#define NORMHOME 		1
#define POSLOSS	 		2
#define STATPOSLOSS 		3

#define STALL_BIT		0x01
#define NORMHOME_BIT		0x02
#define POSLOSS_BIT	 	0x04
#define STATPOSLOSS_BIT 	0x08



/* codes for limit status */

#define MOVECWLIM 	0
#define MOVECCWLIM 	1
#define ATCWLIM		2
#define ATCCWLIM 	3

#define MOVECWLIM_BIT 	0x01
#define MOVECCWLIM_BIT 	0x02
#define ATCWLIM_BIT	0x04
#define ATCCWLIM_BIT 	0x08

/* array indices for encoder function status */

#define ENCODER_MAX_STATUS_BIT 	7

#define ABSOLUTE_MODE		0
#define ENCODER_STEP_MODE	1
#define POS_MAINTENANCE		2
#define STOP_ON_STALL  		3
#define OUTPUT_ON_STALL  	4
#define KILL_ON_TRIGGER_3  	5
#define POST_MOVE_LOSS_DETECT  	6
#define OUTPUT_ON_POS_LOSS     	7


#define  PING_COMMAND   "~p"
#define  PING_STRING    "ping"


/* externs */

extern int triggers[];	/* these should be moved... */
extern int GripPos;
extern int SystemIsCold();


extern void GetLoc();
extern void GetTriggers();
extern void GetBusy();
extern void GetPause();
extern void GetLooped();
extern void GetEncoderFunctionStatus();
extern void printLocation();
extern void gripStatus();
extern void fiborgStatusDump();
extern void Ping();
extern void getString();
